const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const vaccinations = sequelize.define(
    'vaccinations',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

vaccine_name: {
        type: DataTypes.TEXT,
      
      

      },

vaccine_code: {
        type: DataTypes.TEXT,
      
      

      },

recommended_min_age_days: {
        type: DataTypes.INTEGER,
      
      

      },

recommended_max_age_days: {
        type: DataTypes.INTEGER,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  vaccinations.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















    db.vaccinations.hasMany(db.patient_vaccinations, {
      as: 'patient_vaccinations_vaccination',
      foreignKey: {
          name: 'vaccinationId',
      },
      constraints: false,
    });









//end loop



    db.vaccinations.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.vaccinations.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.vaccinations.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return vaccinations;
};


